"""Bagels, 숫자 야구 게임.

Exercises:

1. 비밀의 숫자를 찾아 낼 수 있겠는가?
2. 6자리인 경우 몇 번의 추측이 필요한가?
3. 몇 자리나 늘릴 수 있다고 생각하는가? 자리 수를 늘리려면 어떻게 해야 하는가?
4. 숫자 야구처럼 n 자리가 다르면 n 볼, x 개가 맞으면 x 스트라이크로 표현하도록 바꿔보자

Adapted from code in https://inventwithpython.com/chapter11.html

"""

from random import sample, shuffle

digits = 3
guesses = 10

print('I am thinking of a', digits, 'digit number.')
print('Try to guess what it is.')
print('Here are some clues:')
print('When I say:    That means:')
print('  pico         One digit is correct but in the wrong position.')
print('  fermi        One digit is correct and in the right position.')
print('  bagels       No digit is correct.')
print('There are no repeated digits in the number.')

# Create a random number.

letters = sample('0123456789', digits)

if letters[0] == '0':
    letters.reverse()

number = ''.join(letters)

print('I have thought up a number.')
print('You have', guesses, 'guesses to get it.')

counter = 1

while True:
    print('Guess #', counter)
    guess = input()

    if len(guess) != digits:
        print('Wrong number of digits. Try again!')
        continue

    # Create the clues.

    clues = []

    for index in range(digits):
        if guess[index] == number[index]:
            clues.append('fermi')
        elif guess[index] in number:
            clues.append('pico')

    shuffle(clues)

    if len(clues) == 0:
        print('bagels')
    else:
        print(' '.join(clues))

    counter += 1

    if guess == number:
        print('You got it!')
        break

    if counter > guesses:
        print('You ran out of guesses. The answer was', number)
        break
