# coding: utf-8
'''
계산기 템플릿 코드

1 template 읽어보기
2 template 코드 분석 하기
3 나머지 숫자 입력 패드 생성하기
4 초기화 기능 구현하기
5 곱셉, 나눗셈 연산 구현하기
6 현재 입력 식 표기 구현하기
7 키보드 입력 받기
* 괄호 연산을 구현하려면 무엇이 필요할까?
* 추가 연산자 정의 (공학용 계산기)

'''
from tkinter import *
from tkinter import ttk

temp = 0
mem_clear = False

global operator

def num_button(val):
    global temp
    global mem_clear
    if val == 'AC':
        equation.delete(0, 'end')
        mem_clear = False
        print("AC entered")
    else:
        if mem_clear:
            equation.delete(0, "end")
            mem_clear = False
        equation.insert("end", val)
        print(val, "entered")


def float_filter(val):
    try:
        int(val)
        return int(val)
    except ValueError:
        return float(val)

def int_converter(number):
    if int(number) == float(number):
        return int(number)
    else:
        return float(number)


def op_button(op):
    global operator
    global temp
    global mem_clear
    if not equation.get() == '':
        operator = op
        temp = float_filter(equation.get())
        equation.delete(0, 'end')
        print(temp, operator)


def calc_button():
    global operator
    global temp
    global mem_clear
    if not (operator == '' and equation.get() == ''):
        number = int(equation.get())
        if operator == '+':
            answer = temp + number
        else:
            answer = temp - number

        answer = int_converter(answer)
        equation.delete(0, 'end')
        equation.insert(0, answer)
        print(temp, operator, number, "=", answer)
        operator = ''
        temp = 0
        mem_clear = True


root = Tk()
root.title("Calculator Template")
root.geometry("300x200")

operands = StringVar(root, value='')

equation = ttk.Entry(root, textvariable=operands, width=20)
equation.grid(row=0, columnspan=3)


num_pad1 = ttk.Button(root, text="1", command=lambda: num_button('1'))
num_pad1.grid(row=3, column=0)
num_pad2 = ttk.Button(root, text="2", command=lambda: num_button('2'))
num_pad2.grid(row=3, column=1)
num_pad3 = ttk.Button(root, text="3", command=lambda: num_button('3'))
num_pad3.grid(row=3, column=2)
num_pad_add = ttk.Button(root, text="+", command=lambda: op_button('+'))
num_pad_add.grid(row=3, column=3)

num_pad0 = ttk.Button(root, text="0", command=lambda: num_button('0'))
num_pad0.grid(row=4, column=1)
num_pad_equal = ttk.Button(root, text="=", command=lambda: calc_button())
num_pad_equal.grid(row=4, column=2)
num_pad_sub = ttk.Button(root, text="-", command=lambda: op_button('-'))
num_pad_sub.grid(row=4, column=3)

root.mainloop()
